use axum::{
    Json, Router,
    routing::get,
};

use std::collections::HashMap;

use kontakte::types::{Contact, Organisation, Person};

#[tokio::main]
async fn main() {
    let app = Router::new()
        .route("/", get(root))
        .route("/persons/", get(persons));

    let listener = tokio::net::TcpListener::bind("0.0.0.0:3000").await.unwrap();
    axum::serve(listener, app).await.unwrap();
}

async fn root() -> &'static str {
    "Hello, World!"
}

// fn persons() -> impl Future<Output = String> {
async fn persons() -> Json<HashMap<String, Contact<'static>>> {
    let velocitux = Organisation::new("velocitux UG".to_string(), "info@velocitux.com".to_string());

    let nik = Person::new("George".to_string(), "nik@velocitux.com".to_string())
        .with_first_name("Dominik".to_string());

    // "nik" => nik,
    // "velocitux" => velocitux,
    let mut addressbook: HashMap<String, Contact> = HashMap::with_capacity(2);
    addressbook.insert("nik".to_string(), nik.into());
    addressbook.insert("velocitux".to_string(), velocitux.into());

    addressbook.into()
}
