use crate::types::{Organisation, Person};

#[test]
fn test_person_eq() {
    let tux = Person::new("Pinguin".to_string(), "tux@example.com".to_string())
        .with_first_name("Tux".to_string());
    let tux2 = Person::new("Pinguin".to_string(), "tux@example.com".to_string())
        .with_first_name("Tux".to_string());

    assert_eq!(tux, tux2);
}

#[test]
fn test_person_ne() {
    let tux = Person::new("Pinguin".to_string(), "tux@example.com".to_string())
        .with_first_name("Tux".to_string());
    let tux2 = Person::new("Ponguout".to_string(), "tux@example.com".to_string())
        .with_first_name("Tux".to_string());

    assert_ne!(tux, tux2);
}

#[test]
fn test_org_to_string() {
    let lh = Organisation::new("Linuxhotel".to_string(), "info@linuxhotel.de".to_string());

    assert_eq!(lh.to_string(), "Linuxhotel <info@linuxhotel.de>");
}

#[test]
fn test_person_to_string() {
    let tux = Person::new("Pinguin".to_string(), "tux@example.com".to_string())
        .with_first_name("Tux".to_string());

    assert_eq!(tux.to_string(), "Tux Pinguin <tux@example.com>");
}
